/*
 ============================================================================
 Project     : 1.5+E Approximation Algorithm
 Author      : Lucas Angelo Silveira
               Universidade de Brasilia (UnB) - Brazil
               Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: July 16, 2015.
 ============================================================================
 */

#ifndef _algorithm_h
#define _algorithm_h
//
//  
//
//
//  Created by Lucas Angelo on 03/03/15.
//
//
#include "graph.h"

void set_size(int t);
void print();

void grava();
//sorting graph
void insertionSort(Graph_M * M, int tam);


//search o prox element upper ao parameter
//return o index do upper element
int search_upper(int element);

//search o prox element less ao parameter
//return o index do less element
int search_less(int element);

//1 for when they are neighbors in the same chromossome
int neighbors_genomeB(int element1, int element2);

//qtd chromossomes
void qtd_chromossomes();

//check that the two genes are on the same chromosome A
int same_chromossome(int base, int procura);


//check that the two genes are on the same chromosome B
int same_chromossomeB(int base, int procura);

//indices of the end genes of the chromossomes in A
int * borders_chromossome();

//show up blacks edges
void show_black_edges(Grafo_breakpoint * grafo);


//show up grays edges
void show_grays_edges(Grafo_breakpoint * grafo);

// check if there gray edge between a and b
int is_gray(int a, int b, Grafo_breakpoint * grafo);



//build graph of breakpoits
Grafo_breakpoint *  build_grafo();

void criate_Genomes(int entrada[], int entrada2[]);

//check if is a tail de same crhomossome in genome A
int tail_chromossome(int ind);


int head_chromossome(int ind);


int head_chromossomeB(int ind);

void Step1();


int diferente_crom(int p1, int p2);


//distribute signal to the 2-cycles in M
void Sign_M(Graph_M  *M);




int Check_exclusion( int valor, Grafo_breakpoint * grafo,Graph_M  *M);

//construct RSMSP
void RSMSP(Grafo_breakpoint * grafo, Graph_M  *M , Componentes * comp);

//Create FAB graph
Graph_M  * create_FAB(Grafo_breakpoint * grafo);



//building components
Componentes * build_comp(Graph_M  *M);

//distribution for the sinals of the components
void Step4(Graph_M  *M,  Componentes * comp);

//checks to see if the index is not a limit of chromosome
int not_fronteira(int ind);

int tail_chromossomeB(int ind);



int positiongenomeB(int b);


//distribution of sinals to the genes that not have sinals
void Step5();


//remove the RSMSPs case exists
void Step6(Graph_M  *M,  Componentes * comp);

//distribution of sinals the gnes in the genome A
void Sign_genomeA();
void Kernel();






#endif
