
#include <stdio.h>
#include <stdlib.h>
#include "structure.h"
#include "../Fitness/Processing.c"
#include "Calc_entropy.h"
#include "OBL_alg.h"

float prob_crossover= 0.98;     //Crossover Probability
float porc_selection=0.8;     //% of the population that will be selected for Crossover
float porc_reemp=1.0 - 0.7;         //Pct. of the population from where it will be performed
float prob_mutation=0.018;      //Mutation Probability

//adjust parameter
float limiteentropia;         // % of reset population used in the calc of the entropy

//adjust this parameter
float porc_oposition;   //% of the population that will be selected

float porc_retain;        // % of the Preservation of the population when it is restarted
float probability_ob;
int * identity;
int size;
int sentinela;
int *c;
Genome *a;
void read_permutation_of_archivo(char* name, permutation *perm)
{
    int i,n;
    FILE *filePointer;
    if ((filePointer = fopen(name,"r")) == NULL){
        printf("Warning file not found\n");
    }
    
    else
    {
        //read size of permutation
        fscanf(filePointer,"%d",&n);
        perm->size = n;
        size=n;
        //alocate memory for perm->pi
        perm->pi = malloc(perm->size*sizeof(int));
        //leer permutacion
        for(i=0; i<n; i++)
        {
            fscanf(filePointer,"%d",&perm->pi[i]);
        }
        fscanf(filePointer,"%d",&n);
        identity= (int *) calloc (n, sizeof (int));
        for(i=0; i<n; i++)
        {
            fscanf(filePointer,"%d",&identity[i]);
        }
        
        
    }//end  else
    fclose(filePointer);
}//end read permutation of archivo



// Procedure that generates the initial population

void population_init(population *pob, permutation *perm){
	int i,j,r,n,prob;
	
    //Calc size of population
	n = perm->size;
	pob->sizePopulation =  (int) (n * (log(n) / log(2))); //siz of population = (nlogn); log in base 2
	pob->basePopulation = 0;
	pob->topPopulation = pob->sizePopulation;
    
	pob->limiteSelection = pob->sizePopulation * porc_selection;//limit de population what go to crossover
	pob->baseReplace = pob->sizePopulation * porc_reemp;//base de pob a partir de where will replace
    
	pob->baseDescendencia = pob->sizePopulation;
	pob->topeDescendencia = pob->sizePopulation + pob->limiteSelection;
    
	pob->sizeTotal = pob->topeDescendencia;// tamanho total = poblacion + descendencia
    
    /*alocar memoria*/
	pob->genome = malloc(pob->sizeTotal*sizeof(Genome)); //alocar memoria para poblacion total
    if (pob->genome == NULL)
        printf("pob->genome NULL in population_init(x,x)\n");
    
    for(i=0;i<pob->sizeTotal;i++)
    {
        pob->genome[i].genes = malloc(n * sizeof(int));//alocar memoria para cada genome
        if (pob->genome[i].genes == NULL)
            printf("pob->genome[i].genes NULL in population_init(x,x)\n");
    }
    
	/*create population a partir of  permutacion*/
    // A genome is see with a permutation of concatenation chroms
    
	for(i=pob->basePopulation; i < pob->topPopulation; i++)
    {
        
		for(j = 0; j < perm->size; j++)
        {
            if(perm->pi[j]!=0 && j!=0 && (j+1 < perm->size) && perm->pi[j+1]!=0 && perm->pi[j-1]!=0  )
            {
                r=rand();
                prob = r % 2;//valores entre 0 and 1
                if (prob == 1)
                {
                    pob->genome[i].genes[j] = perm->pi[j];
                    
                }
                else
                {
                    
                    pob->genome[i].genes[j] = perm->pi[j] * -1;
                }
            }//end if
            else
            {
                pob->genome[i].genes[j] = perm->pi[j];

            }
        }//end for interno
        
		pob->genome[i].size = perm->size;
	}//end for extern
	for(i=pob->baseDescendencia; i<pob->topeDescendencia; i++){
		pob->genome[i].size = perm->size;
	}
    
    
}//end create init population

//compute the distance to each genome of the population
void fitness_population(population *pob, int flag){
	int i;
    
	if (flag > 1)
	{
		for(i=pob->baseDescendencia; i < pob->topeDescendencia; i++)
		{
	        	load_genoma( pob->genome[i].genes, identity,pob->genome[i].size, size);
	        	pob->genome[i].fitness = distance(pob->genome[i].genes,identity, pob->genome[i].size,2);
            
	        }
	}
	else
    	{
        	for(i=pob->basePopulation; i < pob->sizePopulation; i++)
        	{
            		load_genoma( pob->genome[i].genes, identity,pob->genome[i].size, size);
            		pob->genome[i].fitness = distance(pob->genome[i].genes,identity, pob->genome[i].size,1);
            
            
        	}
       }
}

void countingSort(population *pob, int k){
	int i,j;
	int *c;//c[k];
	Genome *a;
    
    c = malloc(k*sizeof(int));
    
	a = malloc(pob->sizePopulation*sizeof(Genome));
	if (a == NULL) printf("a NULL en countingSort() \n");
    
    for(i=0;i<pob->sizePopulation;i++){
        a[i].genes = malloc(pob->genome[0].size * sizeof(int));
        if (a[i].genes == NULL)
            printf("a[i].genes NULL en countingSort()\n");
    }
    
	for(i=0; i<pob->sizePopulation; i++){
		a[i].fitness = pob->genome[i].fitness;
        for(j=0; j<pob->genome[0].size; j++)
            a[i].genes[j] = pob->genome[i].genes[j];
	}
    
	/*counting sort*/
	for(i=0; i<k; i++){
		c[i] = 0;
	}
    
	for(i=0; i<pob->sizePopulation; i++){
		c[a[i].fitness] = c[a[i].fitness] + 1;
	}
    
	for(i=1; i<k; i++){
		c[i] = c[i] + c[i-1];
	}
    
	for(i=pob->sizePopulation-1; i>=0; i--){
		
        pob->genome[c[a[i].fitness]-1].fitness = a[i].fitness;
        for(j=0; j<pob->genome[0].size; j++)
            pob->genome[c[a[i].fitness]-1].genes[j] = a[i].genes[j];
        
        
		c[a[i].fitness] = c[a[i].fitness] - 1;
	}
    
    
    for(i=0;i<pob->sizePopulation;i++){
        free(a[i].genes);
    }
	free(a);
    free(c);
}


void selection(population *pob,  int n_generetion, int * best_solution){
	
    countingSort(pob,pob->genome[0].size+2);
    
    if (pob->genome[0].fitness < *best_solution)
        *best_solution = pob->genome[0].fitness;
    
}


void crossover(population *pob, permutation *perm){
	int i,j,k,pos_pai1, pos_pai2, point_crossover;
	float prob;
	k = pob->baseDescendencia;
	for(i=pob->basePopulation; i<pob->limiteSelection; i+=2)
    {
		if (k+1 == pob->sizeTotal)
			break;
        
		pos_pai1 = rand() % pob->limiteSelection;
		pos_pai2 = rand() % pob->limiteSelection;
		for(j=0; j<10; j++){
			if (pos_pai1 != pos_pai2)
                break;
			pos_pai2 = rand() % pob->limiteSelection;
		}
        
		prob = ((rand() % 100) + 1)/100.0; //de 0.01, 0.02 ... a 1.0
		if (prob <= prob_crossover)
	        {//crossover
			point_crossover = rand() % perm->size;
			for(j=0; j<point_crossover; j++){
				pob->genome[k].genes[j] = pob->genome[pos_pai1].genes[j];
				pob->genome[k+1].genes[j] = pob->genome[pos_pai2].genes[j];
			}
			for(j=point_crossover; j<perm->size; j++){
				pob->genome[k+1].genes[j] = pob->genome[pos_pai1].genes[j];
				pob->genome[k].genes[j] = pob->genome[pos_pai2].genes[j];
			}
			k = k + 2;
		}//end if crossover
	}//end for iniit
	pob->topeDescendencia = k;
}

void mutation(population *pob, permutation *perm){
	int i,j;
	float prob;

	for(i=pob->baseDescendencia; i<pob->topeDescendencia; i++)
    {
		for(j=0; j<perm->size; j++)
        {
			prob = ((rand() % 100) + 1)/100.0; //de 0.01, 0.02 ... a 1.0
			
            if(prob <= prob_mutation)
            {//applied a gene mutation (flip sign)
		
		if(pob->genome[i].genes[j]!=0 && j!=0 && (j+1 < size) && pob->genome[i].genes[j+1]!=0 && pob->genome[i].genes[j-1]!=0 )
			pob->genome[i].genes[j] = pob->genome[i].genes[j] * -1;
                
	    }
            
	}
        
    }//end for
    
 }//end of the function mutation


void replacement(population *pob){
	int i,j,pos_reemp;
    int conta=0;
    for(i=pob->baseDescendencia; i<pob->topeDescendencia; i++)
    {
		int tamanhoReemp = pob->topPopulation - pob->baseReplace;
		pos_reemp = (rand() % tamanhoReemp) + pob->baseReplace;
		
		if (pob->genome[i].fitness < pob->genome[pos_reemp].fitness)
     	       {
            		conta++;
            		pob->genome[pos_reemp].fitness = pob->genome[i].fitness;
            		for(j=0; j<pob->genome[0].size; j++)
                		pob->genome[pos_reemp].genes[j] = pob->genome[i].genes[j];
            
               }
	}
  }



/* Function that converts a genome into his opposite from "start" to "end"
 * Whenever it improves it fitness value
 */
int opposite_genome(population *pob, int i, int start, int end){
    
    int k;
    int fitness, better,replace;
    
    int back[pob->genome[i].size];
    for(k=0;k<pob->genome[i].size;k++)
    {
        back[k]=pob->genome[i].genes[k];
    }
    //save the genome
    replace = 0;//false
    better = pob->genome[i].fitness;
    
    //modify the sign of the genes of a genome "i" from start to end
    for (k=start; k<end; k++){
        if((k!=0) && (k != end-1) && (pob->genome[i].genes[k-1]!=0)&& (pob->genome[i].genes[k+1]!=0) && (pob->genome[i].genes[k]!=0))
        pob->genome[i].genes[k] = pob->genome[i].genes[k]*(-1);
    }
    
    load_genoma( pob->genome[i].genes, identity,pob->genome[i].size, size);
    fitness = distance(pob->genome[i].genes,identity, pob->genome[i].size,1);
    
    if (fitness < better){
        pob->genome[i].fitness=fitness;
        replace = 1;//true
    }
    else{
        
        for (k=start; k<end; k++){
            pob->genome[i].genes[k] = back[k];
        }
    }
    
    return replace;
}




/* method that resert the population, conservando una parte
* e gerando aleatoriamente oresto
*/
void restarting_population(population *pob, permutation *perm){
	int i,j, prob,r, size_conservation;
    
	/* retain a portion of the population */
	size_conservation = pob->sizePopulation * porc_retain;
    
	for(i=size_conservation; i < pob->sizePopulation; i++)
    {
		for(j = 0; j < perm->size; j++)
        {
            if(perm->pi[j]!=0 && j!=0 && (j+1 < perm->size) && perm->pi[j+1]!=0 && perm->pi[j-1]!=0  )
            {
                r=rand();
                prob = r % 2;
                if (prob == 1)
                {
                    pob->genome[i].genes[j] = perm->pi[j];
                    
                    
                }
                else
                {
                    
                    pob->genome[i].genes[j] = perm->pi[j] * -1;
                }
            }//end if
            else
            {
                pob->genome[i].genes[j] = perm->pi[j];
            }
        }
        
		pob->genome[i].size = perm->size;
        
        //calculate translocation distance for each genome
        load_genoma( pob->genome[i].genes, identity,pob->genome[i].size, size);
        pob->genome[i].fitness = distance(pob->genome[i].genes,identity, pob->genome[i].size,1);
        opposite_genome(pob, i, 1, pob->genome[0].size);

    
    
    }
    
}//end restarting_population




//this function return 1 for reset population and 0 otherwise
int reset_population(population *pob){
    
    float pop=entropia_shannon(pob);
    if (  pop < limiteentropia)
        return 1;
    else
        return 0;
    
}

void see_population(permutation *perm,population *pob)
{
    int i,j;
    printf("Show Population\n");
    for(i=0; i<pob->sizePopulation;i++ )
    {
        printf("%d ",i);
        for(j=0;j<perm->size;j++)
        {
            printf("%d,", pob->genome[i].genes[j]);
            
        }
        printf("\n");
    }
}//end see_population


void see_fitness(population *pob ,int flag)
{
    int i;
    if(!flag)
    {
        for(i=pob->basePopulation; i < pob->sizePopulation; i++)
            printf("%d: distance is:%d\n",i, pob->genome[i].fitness);
    }
    else
    {
        
        for(i=pob->baseDescendencia; i < pob->topeDescendencia; i++)
            printf("distance is:%d\n",pob->genome[i].fitness);
    }
    
}



// Method that generates the opposites for all the population
void OBL(population *pob, int nro_generation){
    int i; 
    float randomico;
    if (nro_generation > 1){// not is a initial population
        int limite = pob->sizePopulation * porc_oposition;
        
        for(i=pob->basePopulation; i < limite; i++){
            
            randomico=((rand() % 100) + 1)/100.0;
            if (probability_ob > randomico) {
                opposite_genome(pob, i, 1, pob->genome[0].size);

            }
            else if(probability_ob <0.2)
            {
                opposite_genome(pob, i, 1, pob->genome[0].size);
                
            }

            
        }
        
    }
    else{
        for(i=pob->basePopulation; i < pob->topPopulation; i++){
           opposite_genome(pob, i, 0, pob->genome[0].size);
        }
    }
    
    
    
}

void OBLGa(float probreset, float oposition, float probretation)
{
    
    int i;
    permutation perm;
    sentinela=0;
    population pob;
    int best_solution;
    int num_generation;
    read_permutation_of_archivo("GENOME", &perm);// leitura validada
    //check if is-cotail
    if (is_cotail(perm.pi,identity,perm.size, size))
    {
        limiteentropia=0.1;//parameter for compute the etropy of shanoon
        porc_oposition=0.7;
        porc_retain=0.5;
        population_init(&pob, &perm);
        set_TAMANHO_CAPPEPLUS( perm.pi, perm.size);
        load_nodeToCompMap();
        
        fitness_population(&pob, 1);
        OBL(&pob,1);
        best_solution = pob.genome[0].fitness;
        num_generation = perm.size;
        
        for(i=2; i<=num_generation+1; i++)
        {
            selection(&pob,i,&best_solution);
            crossover(&pob, &perm);
            mutation(&pob, &perm);
            fitness_population(&pob,i);
            replacement(&pob);
            probability_ob=(1.0-(i*1.0 /num_generation));
            OBL(&pob,num_generation);
            if (reset_population(&pob))
            {   
                restarting_population(&pob, &perm);
                OBL(&pob,num_generation);
                
            }
         
            
            
       }
        
        
        selection(&pob,i,&best_solution);
       
        /***Free Memory***/
        for(i=0;i<pob.sizeTotal;i++){
            free(pob.genome[i].genes);
        }
        free(pob.genome);
        free(perm.pi);

        printf("Distance OBL-GA:%d\n", best_solution);
        
    }
    else
        printf("******************INPUT NOT IS-COTAIL************************");
    
    
}//end function Genetico





