/*
 ============================================================================
 Project     : Standard Genetic Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: July 16, 2015.
 ============================================================================
 */

#ifndef _Alg_Simple_Genetic_h
#define _Alg_Simple_Genetic_h
#include "structure.h"

void read_permutation_of_archivo(char* name, permutation *perm);



void see_population(permutation *perm,population *pob);


// Procedure that generates the initial population

void population_init(population *pob, permutation *perm);


//flag(0) indica se e um populacao inicial ou (1) se ja contem descentes
void see_fitness(population *pob ,int flag);

//compute the distance to each genome of the population
void fitness_population(population *pob, int flag);


void countingSort(population *pob, int k);


void selection(population *pob,  int n_generetion, int * best_solution);


void crossover(population *pob, permutation *perm);


void mutation(population *pob, permutation *perm);


void replacement(population *pob);



void SimpleGenetic(float probcrossover, float probmutacao, float probselecao, float probsubstituicao);

#endif
